//Rose Flower
class extraPlant {
  
  float size, angle;
  String computedWord;
  String axiom = "[A][B][C]";
  
  String [][] rules = {{"F", "F"},
                       {"A", "[+A]C"},
                       {"B", "[-B]C"},
                       {"C", "FFFC"},
                       {"+", "+"},
                       {"-", "-"}, 
                       {"[", "["},
                       {"]", "]"}};
  
  
  extraPlant(float size, float angle){
   this.size = size;
   this.angle = angle;
   computedWord = axiom;    
  }
  
  
 void iterateExtra(int iterations){
    String newWord;
    println("Starting word: " + computedWord);
    for(int i = 0; i < iterations; i++) {
      newWord = computedWord;
      computedWord = "";
      //loop through word
      for(int j = 0; j < newWord.length(); j++) {
        char c = newWord.charAt(j);
        //loop through rules
        for(int k = 0; k < rules.length; k++) { 
          if (c == rules[k][0].charAt(0)) {
            computedWord = computedWord + rules[k][1];
            break;
          }
        }
      }
      println("Iteration " + i +": " + computedWord);
    }
  }
  
    void drawExtraPlant(Turtle t){
     t.setX(width/2);
     t.setY(height-300);
      for (int i=0; i<computedWord.length(); i++) {
        char c = computedWord.charAt(i);
        if (c == 'F'){
          t.forward(size);
          fill(#48FF9C);
          //stroke(#4B9D57);         
        }
        else if (c == 'A'){
          t.forward(size);
          fill(#48FF9C);
          //stroke(#4B9D57);
          t.right(angle);
        }
        else if (c == 'B'){
          t.forward(size);
          fill(#48FF9C);
          //stroke(#4B9D57);
          t.right(angle);
        }
        else if (c == 'C'){
          t.forward(size);
          fill(#48FF9C);
          //stroke(#4B9D57);
          t.right(angle);
        }
        else if (c == '+')
          t.right(angle);
        else if (c == '-')
          t.left(angle);
        else if (c == '[')
          t.push();
        else if (c == ']')
          t.pop();
    }
  }
}
