class leaf{
  
  float size, angle;
  String computedWord;
  String axiom = "XF";
  
  String [][] rules = {{"F", "FF"},
                       {"X", "F[-X]+F+[+X]F"},
                       {"R", ""},
                       {"L", ""},
                       {"+", "+"},
                       {"-", "-"}, 
                       {"[", "["},
                       {"]", "]"}};
  
  
  leaf(float size, float angle) {
    this.size = size;
    this.angle = angle;    
    computedWord = axiom;
  }
  
  void iterateLeaf(int iterations){
    String newWord = "";
    println("Starting word: " + computedWord);
    for(int i = 0; i < iterations; i++) {
      newWord = computedWord;
      computedWord = "";
      //loop through word
      for(int j = 0; j < newWord.length(); j++) {
        char c = newWord.charAt(j);
        //loop through rules
        for(int k = 0; k < rules.length; k++) { 
          if (c == rules[k][0].charAt(0)) {
            computedWord = computedWord + rules[k][1];
            //computedWord = computedWord + rules[k][(int)random(0, 4)];
            break;
          }
        }
      }
      println("Iteration " + i +": " + computedWord);
    }
  }
  
  void drawLeaf(Turtle t){
     t.setX(width/2);
     t.setY(height-305);
      for (int i = 0; i < computedWord.length(); i++) {
        char c = computedWord.charAt(i);
        if (c == 'F'){
          t.forward(size);
          fill(#48FF9C);
          ellipse(t.getX(), t.getY(), 20,10);
          noStroke();
        }
        else if (c == 'X'){
        fill(#48FF9C);
        noStroke();
        ellipse(t.getX(), t.getY(), 20,4);
        stroke(0);
        fill(255,0,0);
        }
        else if (c == 'L'){
          stroke(#FF4857);
          t.back(size);         
        }
        else if (c == 'R')
          t.forward(size);
        else if (c == '+')
          t.right(angle);
        else if (c == '-')
          t.left(angle);
        else if (c == '[')
          t.push();
        else if (c == ']')
          t.pop();
      }
  }  
}
