//Thistle
class plantTwo {
  
  float size, angle;
  String computedWord;
  String axiom = "[C[X[A]][D[Y][B]]]";
  
  String [][] rules = {{"F", "F[-X][+X][F]"},
                       {"X", "F[+[+[+[+A]C]FC]FFC]FFFC"},
                       {"C", "F[+C][+X][-X][-C]XFYF"},
                       {"A", "[+A]C[-B]D"},
                       {"Y", "F[-[-[-[-B]D]FD]FFD]FFFD"},
                       {"D", "F[-D][-Y][+Y][+C]YFYF"},
                       {"B", "[-B]D"},
                       {"+", "+"},
                       {"-", "-"}, 
                       {"[", "["},
                       {"]", "]"}};  
  
  plantTwo(float size, float angle){
   this.size = size;
   this.angle = angle;
   computedWord = axiom;    
  }
  
  
 void iterate2(int iterations){
    String newWord;
    println("Starting word: " + computedWord);
    for(int i = 0; i < iterations; i++) {
      newWord = computedWord;
      computedWord = "";
      //loop through word
      for(int j = 0; j < newWord.length(); j++) {
        char c = newWord.charAt(j);
        //loop through rules
        for(int k = 0; k < rules.length; k++) { 
          if (c == rules[k][0].charAt(0)) {
            computedWord = computedWord + rules[k][1];
            break;
          }
        }
      }
      println("Iteration " + i +": " + computedWord);
    }
  }
  
    void drawPlantTwo(Turtle t){
     t.setX(width/1.5);
     t.setY(height-50);
      for (int i=0; i<computedWord.length(); i++) {
        char c = computedWord.charAt(i);
        if (c == 'F'){
          t.forward(size);
          stroke(#C46BDE);
          //fill(#48FF9C);
          //stroke(#4B9D57);         
        }
        else if (c == 'X'){
         t.forward(size);
         stroke(#4B9D57);
         t.right(-30);
         t.forward(size);
         stroke(#0FD802);
        }
         else if (c == 'Y'){
          t.forward(size);
          t.right(90);
          t.right(90);
          t.forward(size);
          //t.right(60);
          //t.right(60);
          //t.right(60);
        }
        else if (c == 'A'){
          t.forward(size);
          fill(#48FF9C);
          //stroke(#4B9D57);
          t.right(angle);
        }
        else if (c == 'B'){
          t.forward(size);
          fill(#48FF9C);
          //stroke(#4B9D57);
          t.left(angle);
        }
        else if (c == 'C'){
          t.forward(size);
          fill(#48FF9C);
          //stroke(#4B9D57);
          t.right(angle);
        }
          else if (c == 'D'){
          t.forward(size);
          fill(#48FF9C);
          //stroke(#4B9D57);
          t.left(angle);
        }
        else if (c == '+')
          t.right(angle);
        else if (c == '-')
          t.left(angle);
        else if (c == '[')
          t.push();
        else if (c == ']')
          t.pop();
    }
  }
}
