/*****************************************
 * Large Assignment 1: L-Systems
 * Name:        Michaela Urich
 * E-mail:      murich@unm.edu
 * Course:      CS491, Computational Fabrication
 * Submitted:   09/14/2023 
 
 Instructions:
 press ' ' to clear the canvas
 press '1' for plant 1 -> Lavender
 press '2' for plant 2 -> Poky Plant (takes extra time to load due to complexity)
 press '3' for plant 3 -> Peppercorns
 press 'e' for extra plant -> Rose
 press 's' to save image as .png
 ****************************************/
 
 import Turtle.*;
 
 Turtle t;
 plantOne one;
 plantTwo two;
 plantThree three;
 extraPlant extra;
 leaf leaff;
 flower rose;
 int strokeColor;
 
 void setup() {
   size(1100, 900);
   //background(#FFD6E8);
   background(#AFEAFF);
   println("Background is set.");
   stroke(strokeColor);
   //frameRate(1);
 }
 
 void draw() {  

 }
    

void keyPressed(){ 
  println("Choice is running. ");
 //plantOne
   if (key == '1'){
     t = new Turtle(this);

     strokeColor = #FF4857;
     for (int i = 0; i < 3; i++){
       one = new plantOne(30, 35); //size, angle
       one.iterate1(6);
       one.drawPlantOne(t);
         
     }
     println("You chose the plant number 1! It's a lavender bush.");
   }
   
    //plantTwo
   else if (key == '2'){
     t = new Turtle(this);
     //t.setX(width/2);
     //t.setY(height-10);
     strokeColor = #8E803C;
     for (int i = 0; i < 3; i++){
       two = new plantTwo(11, 19); //size, angle
       two.iterate2(4);
       two.drawPlantTwo(t);
     }
     println("You chose the plant number 2! It's a thistle.");
   } 
   
    //plantThree
   else if (key == '3'){
     t = new Turtle(this);
     //t.setX(width/2);
     //t.setY(height-10);
     strokeColor = #8E803C;
     for (int i = 0; i < 3; i++){
       three = new plantThree(22, 16); //size, angle
       three.iterate3(4);
       three.drawPlantThree(t);
     }
     println("You chose the plant number 3! It's a cluster of peppercorns.");
   } 
   
 //extra plant
   else if (key == 'e'){
     t = new Turtle(this);
     strokeColor = #27C7CB;
     for (int i = 0; i < 3; i++){
       extra = new extraPlant(30, 45); //size, angle
       leaff = new leaf(2, 35); //size, angle
       rose = new flower(3, 25); //size, angle
       
       extra.iterateExtra(2);
       leaff.iterateLeaf(3); 
       rose.iterateFlower(3);
       
       extra.drawExtraPlant(t);
       leaff.drawLeaf(t);
       rose.drawFlower(t);
       
     } 
     println("You chose the extra plant! It's a rose for you!");
   }
   
   //Save image as .png
   else if (key == 's'){
    //Unique file name for 
    String filename = "HomeworkImageMU" + random(1, 100) + ".png";
    save(filename);
    println("Saved a File: " + filename);    
   }
   
   //Clear
   else if(key == ' '){
    clear();
    println("All clear!!!");
    setup();
  }
 }
 

 
 
 
