//Lavender Bush
class plantOne{
  
  float size, angle;
  String computedWord;
  String axiom = "X";
  
  String [][] rules = {{"F", "F"},
                       {"X", "F[+X][-X]FX"},
                       //{"L", ""},
                       {"+", "+"},
                       {"-", "-"}, 
                       {"[", "["},
                       {"]", "]"}};
  
  
  plantOne(float size, float angle) {
    this.size = size;
    this.angle = angle;    
    computedWord = axiom;
  }
  
  void iterate1(int iterations){
    String newWord = "";
    println("Starting word: " + computedWord);
    for(int i = 0; i < iterations; i++) {
      newWord = computedWord;
      computedWord = "";
      //loop through word
      for(int j = 0; j < newWord.length(); j++) {
        char c = newWord.charAt(j);
        //loop through rules
        for(int k = 0; k < rules.length; k++) { 
          if (c == rules[k][0].charAt(0)) {
            computedWord = computedWord + rules[k][1];
            //computedWord = computedWord + rules[k][(int)random(0, 4)];
            break;
          }
        }
      }
      println("Iteration " + i +": " + computedWord);
    }
  }
  
  void drawPlantOne(Turtle t){
     t.setX(width/2);
     t.setY(height-300);
     
      for (int i = 0; i < computedWord.length(); i++) {
        char c = computedWord.charAt(i);
        if (c == 'F')
          t.forward(size);
        else if (c == 'X'){
          stroke(#177949);
          t.forward(size);
          fill(#177949);
          t.right(10);
          t.forward(size);
          fill(#DFBEF7);
          noStroke();
          ellipse(t.getX(), t.getY(), 20,4);
          stroke(0);
          fill(255,0,0);
        }
        else if (c == '+')
          t.right(angle);
        else if (c == '-')
          t.left(angle);
        else if (c == '[')
          t.push();
        else if (c == ']')
          t.pop();
      }
  }  
}
