//Peppercorn Cluster
class plantThree {
  
  float size, angle;
  String computedWord;
  String axiom = "X";
  
  String [][] rules =  {{"F", "FF"},
                        {"X", "F[[MGX]+XLP]+FL[L-F-G]++[+[FX]-MP"},
                        {"L", "FG[[XP]+XP]+F[+FX]-XM"}, 
                        {"P", "F[-FX][+XFMP]"},
                        {"M", "F[++X][+MLF]"},
                        {"G", "F[-XFXM][+GFGLF]XPF"},
                        {"+", "+", "+", "+"},
                        {"-", "-", "-", "-"},
                        {"[", "[", "[", "["},
                        {"]", "]", "]", "]"}};  
  
  plantThree(float size, float angle){
   this.size = size;
   this.angle = angle;
   computedWord = axiom;    
  }
  
  
 void iterate3(int iterations){
    String newWord;
    println("Starting word: " + computedWord);
    for(int i = 0; i < iterations; i++) {
      newWord = computedWord;
      computedWord = "";
      //loop through word
      for(int j = 0; j < newWord.length(); j++) {
        char c = newWord.charAt(j);
        //loop through rules
        for(int k = 0; k < rules.length; k++) { 
          if (c == rules[k][0].charAt(0)) {
            computedWord = computedWord + rules[k][1];
            break;
          }
        }
      }
      println("Iteration " + i +": " + computedWord);
    }
  }
  
    void drawPlantThree(Turtle t){
      background(#A9D19E);
      t.setX(width/21);
      t.setY(height-600);
      
      for (int i=0; i<computedWord.length(); i++) {
        char c = computedWord.charAt(i);
        if (c == 'F'){
          t.forward(size);
          //fill(#744E25);
          //stroke(#744E25);
          stroke(2);          
        }
        else if (c == 'L'){
          t.forward(size);
          fill(#CE0889);
          stroke(#CE0889);
          ellipse(t.getX(), t.getY(), 11,10);
          fill(#CE0889);          
        }
        else if (c == 'P'){
          t.forward(size);
          fill(#D86B2C);
          stroke(#D86B2C);
          ellipse(t.getX(), t.getY(), 11,10);
          fill(#D86B2C);
        }
        else if (c == 'M'){
          t.forward(size);
          fill(#EEF231);
          stroke(#EEF231);
          ellipse(t.getX(), t.getY(), 11,10);
          fill(#EEF231);
        }
        else if (c == 'G'){
          t.forward(size);
          fill(#5AC43D);
          stroke(#5AC43D);
          ellipse(t.getX(), t.getY(), 11,10);
          fill(#5AC43D);
        }
        else if (c == 'C'){
          t.forward(size);
          fill(#48FF9C);
          stroke(#4B9D57);
        }
        else if (c == '+')
          t.right(angle);
        else if (c == '-')
          t.left(angle);
        else if (c == '[')
          t.push();
        else if (c == ']')
          t.pop();
    }
  }
}
